tienda_electronica/tienda/urls.py
from django.contrib import admin
from django.urls import path
from .views import HomeView, OfertaView,VerProductosView, CrearVentaView, MisVentasView

app_name = 'tienda'

urlpatterns = [
    path('', HomeView.as_view(), name="index"),
    path('oferta/', OfertaView.as_view(), name="oferta"),
    path('home-productos/productos/', VerProductosView.as_view(), name="ver-productos"),
    path('venta/', CrearVentaView.as_view(), name="crear-venta"),
    path('mis-ventas/', MisVentasView.as_view(), name="ver-mis-ventas"),

]

tienda_electronica/tienda_electronica/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('administracion.urls')),
    path('tienda/',include('tienda.urls')),

]

tienda_electronica/tienda/models.py
from django.db import models

# Create your models here.

tienda_electronica/tienda/views.py
# Create your views here.
from django.shortcuts import render, redirect
from django.views import View
from administracion.models import ProductoModel, VentaModel, ProductoModel, TiendaModel, VendedorModel
from administracion.forms import VentaForm
from django.contrib.auth.decorators import login_required
from django.utils.decorators import method_decorator
import datetime
from administracion.valor_dolar import InfoApi
from django.contrib import messages


# Create your views here.

class HomeView(View):
    @method_decorator(login_required(login_url='administracion:login'))
    def get(self,request):

        try:
            vendedor = VendedorModel.objects.get(nombre_usuario = request.user.username)
            tienda = vendedor.tienda_asignada.nombre
        except:
            tienda = "No asignada"
        return render(request,'tienda/index.html',{"tienda":tienda})


class OfertaView(View):
    @method_decorator(login_required(login_url='administracion:login'))
    def get(self,request):
        return render(request,'tienda/oferta.html',{})


class VerProductosView(View):
    @method_decorator(login_required(login_url='administracion:login'))
    def get(self, request):

        vendedor = VendedorModel.objects.get(nombre_usuario = request.user.username)
        tienda = vendedor.tienda_asignada

        lista_productos = ProductoModel.objects.filter(tienda_asignada=tienda)

        return render(request, 'tienda/productos.html',{'productos':lista_productos, 'dolar':InfoApi()})


class CrearVentaView(View):
    @method_decorator(login_required(login_url='administracion:login'))
    def get(self, request):        
        #se obtiene el nombre de la tienda del vendedor logeado
        nombre_tienda = VendedorModel.objects.get(nombre_usuario=request.user.username).tienda_asignada.nombre    
        #se obtiene el Objeto Tienda
        tienda = TiendaModel.objects.get(nombre=nombre_tienda)      
        #se obtienen todos los productos disponibles de la tienda
        
        lista_productos=ProductoModel.objects.filter(tienda_asignada=tienda)        
        ventas = VentaModel.objects.all()
        if len(ventas)==0:
            nro_venta = 1
        else:
            orden= ventas.order_by("-nro_venta")
            mayor = orden[0].nro_venta
            if orden[0].estado:
                nro_venta = mayor+1
            else:
                nro_venta = mayor
        productos_agregados = VentaModel.objects.filter(nro_venta=nro_venta)
        context = {"tienda":nombre_tienda,"productos":lista_productos,'vendedor':request.user.username, 
                    "nro_venta":nro_venta, 'productos_agregados':productos_agregados, 'hoy':datetime.datetime.today()}
                    #'productos_agregados':productos_venta,
        return render(request,'tienda/venta.html',context)
    
    @method_decorator(login_required(login_url='administracion:login'))
    def post(self, request):      
        if request.POST["event"]=="agregar":
            #ATRIBUTOS VENTA = nro_venta, tienda, producto, cantidad, total
            if not request.POST.get("lista_productos")=="NOSELECT":
                req = request.POST
                if req.get("cantidad")!="" and req.get("precio")!="" and req.get("total")!="":
                    producto_nombre = request.POST.get("lista_productos").split("-")[0]
                    producto = ProductoModel.objects.get(nombre=producto_nombre)                
                    venta = VentaModel() 
                    info = self.obtener_info(request)          
                    venta.nro_venta= info[0]
                    venta.tienda = info[1]
                    venta.producto = info[2]
                    venta.cantidad = info[3]
                    venta.total = info[4]
                    venta.vendedor = VendedorModel.objects.get(nombre_usuario=request.user.username)
                    venta.estado = False
                    venta.fecha=datetime.datetime.now()
                    venta.total_dolar = round(venta.total/InfoApi(),2)
                    venta.precio_dolar = round(producto.precio/InfoApi(),2)
                    venta.save()
                    return redirect('tienda:crear-venta')
                else:
                    return redirect('tienda:crear-venta')            
            else:
                return redirect('tienda:crear-venta')
        elif "eliminar" in request.POST["event"]:         
            id=request.POST["event"].split("-")[1]
            venta = VentaModel.objects.get(id=id).delete()
            messages.info(request,"Item eliminado correctamente")

            return redirect('tienda:crear-venta')
        elif request.POST["event"]=="cancelar":
            ventas = VentaModel.objects.all()
            if len(ventas)==0:
                nro_venta = 1
            else:
                orden= ventas.order_by("-nro_venta")
                mayor = orden[0].nro_venta
                if orden[0].estado:
                    nro_venta = mayor+1
                else:
                    nro_venta = mayor
            VentaModel.objects.filter(nro_venta=nro_venta).delete()
            messages.info(request,"Venta cancelada")
            return redirect("tienda:index")
        
        elif request.POST["event"]=="guardar":
            ventas = VentaModel.objects.all()
            if len(ventas)==0:
                nro_venta = 1
            else:
                orden= ventas.order_by("-nro_venta")
                mayor = orden[0].nro_venta
                if orden[0].estado:
                    nro_venta = mayor+1
                else:
                    nro_venta = mayor
            if len(VentaModel.objects.filter(nro_venta=nro_venta))>0:
                VentaModel.objects.filter(nro_venta=nro_venta).update(estado=True,fecha=datetime.datetime.now())
                messages.info(request,"Venta realizada exitosamente")
            else:
                messages.info(request,"Debe agregar items para realizar una venta")
                return redirect("tienda:crear-venta")
            return redirect("tienda:index")
        
    def obtener_info(self, request):
        nombre_tienda = VendedorModel.objects.get(nombre_usuario=request.user.username).tienda_asignada.nombre    
        tienda = TiendaModel.objects.get(nombre=nombre_tienda) 
        ventas = VentaModel.objects.all()
        if len(ventas)==0:
            nro_venta = 1
        else:
            orden= ventas.order_by("-nro_venta")
            mayor = orden[0].nro_venta
            if orden[0].estado:
                nro_venta = mayor+1
            else:
                nro_venta = mayor
        nombre_producto = request.POST.get("lista_productos").split("-")[0]
        producto = ProductoModel.objects.get(nombre=nombre_producto)
        cantidad = int(request.POST.get("cantidad"))
        total = cantidad * producto.precio
        return [nro_venta, tienda, producto, cantidad, total]

class MisVentasView(View):
    @method_decorator(login_required(login_url='administracion:login'))
    def get(self, request):     
        vendedor = VendedorModel.objects.get(nombre_usuario=request.user.username)
        dolar = InfoApi()
        ventas = VentaModel.objects.filter(vendedor=vendedor)
        contador_ventas = 0
        total_ventas = 0
        total_ventas_usd = 0
        no_repite = []
        for venta in ventas:
            if venta.nro_venta not in no_repite:
                contador_ventas+=1
                no_repite.append(venta.nro_venta)
            total_ventas += venta.total
            total_ventas_usd += venta.total_dolar
        context = {'vendedor':vendedor,'dolar':dolar,'cantidad_ventas':contador_ventas,
                    'total_ventas':total_ventas,'total_ventas_usd':total_ventas_usd}
        
        return render(request, 'tienda/mis_ventas.html', context) 

tienda_electronica/tienda/templates/tienda/index.html
{% extends 'base.html' %}
{% block title %}
Tienda
{% endblock  %}
{% block functions%}
{% endblock%}
{% block body %}

<section class="container col-lg-4">
    <br>
    <h2 class="text-center">Tienda: {{tienda}}</h2>
    <br>
    {%for message in messages %}
        <div class="alert alert-info" role="alert">
            {{message}}
        </div>
    {% endfor %}
    <a href="{% url 'tienda:ver-productos' %}" class="btn btn-primary col-lg-12">Lista de productos</a>
    <a href="{% url 'tienda:crear-venta' %}" class="btn btn-primary col-lg-12 mt-2">Vender</a>
    <a href="{% url 'tienda:ver-mis-ventas' %}" class="btn btn-primary col-lg-12 mt-2">Ver mis ventas</a>


</section>


{% endblock %}

tienda_electronica/tienda/templates/tienda/mis_ventas.html
{% extends 'base.html' %}
{% block title %}
Tienda
{% endblock  %}
{% block functions%}
{% endblock%}
{% block body %}

<section class="container col-lg-4">
    <br>
    <h2 class="text-center">Mis ventas <br>{{vendedor}}, Tienda: {{vendedor.tienda_asignada}}</h2>
    <br>
    <h4>Valor del dolar hoy en CLP: ${{dolar}}</h4>
    <br>
    <table class="col-12 table table-bordered table-striped">
        <thead >
            <tr>
                <th>Cantidad de ventas</th>
                <th>Total vendido</th>
                <th>Total vendido en USD</th>
            </tr>
        </thead>  
        <tbody>
            <tr>
                <td>{{cantidad_ventas}}</td>
                <td>{{total_ventas}}</td>
                <td>{{total_ventas_usd}}</td>            
            </tr>

        </tbody>  
    </table>
    <a href="{% url 'tienda:index' %}" class="btn btn-warning col-lg-2">Regresar</a>

</section>


{% endblock %}

tienda_electronica/tienda/templates/tienda/oferta.html
{% extends 'base.html' %}
{% block title %}
Oferta
{% endblock  %}
{% block functions%}
{% endblock%}
{% block body %}

<h1>INDEX DE OFERTA</h1>


{% endblock  %}

tienda_electronica/tienda/templates/tienda/productos.html
{% extends 'base.html' %}
{% block title %}
Adm - Tiendas
{% endblock  %}
{% block functions%}
{% endblock%}
{% block body %}

<section class="container col-lg-4">
    <br>
    <h2>Productos disponibles</h2>
    <br>

   
        {% if productos %}
            <h4>Valor del dolar hoy en CLP: ${{dolar}}</h4>
            <table class="col-12 table table-bordered table-striped">
            <thead >
                <tr>
                    <th>Nombre</th>
                    <th>Tipo Producto</th>
                    <th>Descripción</th>
                    <th>Tienda</th>
                    <th>Precio</th>
                    <th>Descto. Aplicado</th>
                    
                </tr>
            </thead>  
            <tbody>
                {% for producto in productos %}                    
                    <td>{{producto.nombre|title}}</td>
                    <td>{{producto.tipo_producto|title}}</td>
                    <td>{{producto.descripcion|title}}</td>
                    <td>{{producto.tienda_asignada|title}}</td>                    
                    <td>{{producto.precio}}</td>
                    {% if not producto.tiene_oferta %}
                    <td>N/A</td>
                    {%else%}
                    <td>{{producto.tiene_oferta.porcentaje_descuento}}%</td>                                                 
                    {%endif%}
                </tr>
                {% endfor %}
            </tbody>  
        </table>
        {% else %}
            <h5>Hasta el momento no hay productos ingresados</h5>           
        {% endif %}










    <!-- -->


    
<a href="{% url 'tienda:index' %}" class="btn btn-warning col-lg-2">Regresar</a>
</section>


{% endblock  %}

tienda_electronica/tienda/templates/tienda/venta.html
{% extends 'base.html' %}
{% block title %}
Tienda - Venta
{% endblock  %}

{% block functions%}
function calculartotal(event)
    {             
        console.log(event.srcElement.value)  
        var cantidad = event.srcElement.value
        var precio =   document.getElementById("precio").value;        
        var total = precio * cantidad
        document.getElementById("total").value = total 
    }

function completarPrecio(event)
{
    var precio = document.getElementById("lista_productos").value.split("-")[1];
    document.getElementById("precio").value = precio 
}

$(document).on('click', '#eliminar', function(event){
    event.preventDefault();
    $(this).closest('tr').remove();
});
{% endblock%}

{% block body %}

<section class="container col-lg-6">
    <br>
    <h2>Realizar nueva venta</h2>
    <br>
    <h5>Tienda: {{tienda}}</h5>
    <h6>Vendedor: {{vendedor}}</h6>
    <h6>Num. Venta: {{nro_venta}}</h6>
    <h6>Fecha: {{hoy}}</h6>
    <br>
    {%for message in messages %}
        <div class="alert alert-info" role="alert">
            {{message}}
        </div>
    {% endfor %}
    <form method="post" class="container">
        {% csrf_token %}
        
        <label for="lista_productos">Agregar producto</label><br>
        <select class="custom-select col-4" name="lista_productos" id="lista_productos" onchange="return completarPrecio(event)">
            <option value="NOSELECT">Seleccione un producto</option>
            {% for producto in productos %}
                <option value="{{producto}}-{{producto.precio}}">{{producto}}</option>
            {% endfor %}
        </select>
        <br><label for="cantidad" >Cantidad</label>
        <input type="number" onkeyup="return calculartotal(event)" id="cantidad" name="cantidad" class="form-control col-4">
       
        
        <label for="precio">Precio</label>
        <input type="number" readonly id="precio" name="precio" class="form-control col-4">
        <label for="total">Total</label>
        <input type="number"  readonly id="total" name="total" class="form-control col-4">
        <br><button type="submit" class="btn btn-success" name="event" value="agregar">Agregar</button>
    </form>
    <br> 


    <form method="post">
    {% csrf_token %}
    <table class="col-12">
        <thead >
            <tr>
                <th>ID</th>
                <th>Producto</th>
                <th>Tipo</th>
                <th>Cantidad</th>
                <th>Precio Unit.</th>
                <th>Precio final</th>
                <th>Borrar</th>
            </tr>
        </thead>  
        <tbody>
            {% for venta in productos_agregados %}
            <tr name="id_venta" value="{{venta.id}}">
                <td>{{venta.id}}</td>
                <td>{{venta.producto.nombre}}</td>
                <td>{{venta.producto.tipo_producto}}</td>
                <td>{{venta.cantidad}}</td>
                <td>{{venta.producto.precio}}</td>
                <td>{{venta.total}}</td>
                <td><button type="submit" class="btn btn-danger" name="event" value="eliminar-{{venta.id}}">x</button></td>
            </tr>
            {% endfor %}
        </tbody>  
    </table>
    <br>
    <button type="submit" class="btn btn-success" name="event" value="guardar">Generar venta</button>
    <button type="submit" class="btn btn-warning" name="event" value="cancelar">Cancelar venta</button>
    </form>
        

</section>


{% endblock  %}